#ifndef symbols_h
#define symbols_h

/* This is the symbol table definitions.
 *
 * $Log: symbols.h,v $
 * Revision 1.2  1997/06/04 04:28:56  david
 * ANSI-fied program.
 *
 */

#ifdef DECLARE_IDS
static char *SymbolsID = "$Id: symbols.h,v 1.2 1997/06/04 04:28:56 david Exp $";
#endif /* DECLARE_IDS */

enum symclass
   {
   NOCHANGE,    /* Don't change this on insert */
   NORMAL,	/* This is the default */
   EXTERN,	/* Declared EXTERNal */
   PUBLIC	/* Declared PUBLIC */
   };

enum symtype
   {
   REL, ABS	/* Relocatable or Absolute */
   };

enum symseg
   {
   ASEG, CSEG, DSEG /* Symbol Segment type */
   };

struct xref
   {
   int line; /* Which line? */
   struct xref *next; /* Pointer to next xref */
   };

struct symtab
   {
   struct symtab *next; /* Pointer to next symbol */
   char muldef;         /* 'M' if symbol Multiply defined */
   enum symclass class; /* Class of symbol */
   enum symtype type;   /* Type of symbol
   enum symseg seg;     /* Type of segment */
   WORD value;          /* Value of symbol */
   char *name;          /* Name of Symbol */
   int  line;           /* Line that symbol is defined on */
   struct xref *xptr;   /* Pointer to Cross Reference structure lines */
   };

struct symtab *symfind( char *, int ); /* Find a symbol and its pointer */
void symins( char *, WORD, char, enum symclass ); /* Insert a symbol in the table */
void xrefins( struct symtab *, char );
void xrefdisp( void );

#endif /* symbols_h */
