#ifndef xasm_h
#define xasm_h

/* These are common definitions to the 8 bit assembler and subroutines.
 *
 * $Log: xasm.h,v $
 * Revision 1.3  1997/06/13 07:44:24  david
 * No reason I can think of to take out debugging.
 *
 * Revision 1.2  1997/06/04 04:28:56  david
 * ANSI-fied program.
 *
 */

#include <stdio.h>

#ifdef DECLARE_IDS
static char *XasmID = "$Id: xasm.h,v 1.3 1997/06/13 07:44:24 david Exp $";
#endif /* DECLARE_IDS */

#define BYTE unsigned char
#define WORD unsigned short int

#if DEBUG
#define YYDEBUG 1
#define LEXDEBUG 1
extern int debug;
extern int yydebug;
#endif /* DEBUG */

/* These are some common variables */
extern int errnum; /* Number of errors this pass */
extern int line; /* Line # */
extern int pass; /* Assembler pass # */

extern WORD loc; /* Current location pointer */
extern WORD locinc; /* Amount to increment location pointer */
extern WORD start;  /* Place to start processing */
extern char *filename; /* Name of Assembler file */
extern char fwdref; /* Forward reference flag (see symtab.c,proper.c) */
extern char parse_flag; /* Determines if psuedop has been called before */
extern int psuedop; /* Psuedo Operation flag */
extern char listing; /* Tells whether or not to print listing */

int atob( char * );
int atoh( char * );
void db( int, int, char * );
void dbdata( int );
void dbstr( char * );
void doline( char * );
int doparse( char *, char **, char **, char ** );
void ds( int, char * );
void dw( int, int, char * );
void equ( char *, int, char * );
void extrn( char *, char * );
void initobj( char *, int );
void genobj( char * );
void genintel( char * );
void outintel( int, char * );
void chk( char * );
void ichk( unsigned char );
void gensym( char * );
void outsym( int, char * );
FILE *osfile( char *, long );
char *getline( void );
void rsfile( void );
long ftfile( void );
int csfile( void );
void aif( int, char * );
void include( char *, char * );
int deinclude( void );
void labproc( char * );
void xerror( char * );
void org( int, char * );
int parse( char **, char *, int, char * );
char *pos( char, char * );
void printl( long, char *, char, char * );
void public( char *, char * );
void srchrep( char *, int, char *, char * );
int strcmpi( char *, char * );
char *upper( char * );
void xpend( int, char * );
void yyerror( char * );

char *proper();

#define COMMENT ';'

#endif /* xasm_h */
